diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/fillpanel.py sketch1/Sketch/UI/fillpanel.py
--- sketch.orig/Sketch/UI/fillpanel.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/UI/fillpanel.py	2005-03-19 21:36:01.000000000 +0100
@@ -1,3 +1,7 @@
+# TODO:
+#
+# - check whether the selection changed before removing the und info
+
 # Sketch - A Python-based interactive drawing program
 # Copyright (C) 1997, 1998, 1999, 2000, 2001, 2003 by Bernhard Herzog
 #
@@ -21,17 +25,21 @@
 
 import Sketch
 import Sketch.Graphics
-from Sketch import _, Rect, Trafo, Point, Polar, _skgtk
+from Sketch import _, const, Rect, Trafo, Point, Polar, _skgtk
 from Sketch.Base import Publisher
-from Sketch.Base.const import EDITED, CHANGED
+from Sketch.Base.const import EDITED, CHANGED, SELECTION, OBJECT_CHANGED
 from Sketch.Graphics import StandardColors, EmptyLineStyle, PropertyStack,\
      LinearGradient, RadialGradient, ConicalGradient, HatchingPattern, \
      EmptyPattern, SolidPattern, CreateRGBColor, CreateSimpleGradient, \
      MultiGradient
+from Sketch import Editor
 from Sketch.Editor.const import ConstraintMask
+from gtkmisc import SketchDrawingArea, get_color
+from skpanel import MultiPanel, PanelMenu, Card
+from command import make_command
+from request import ColorButton, ColorRequestButton 
 
-from gtkmisc import SketchDrawingArea, get_color, ColorButton
-from skpanel import SketchPanel
+import dnd
 import skpixmaps
 pixmaps = skpixmaps.pixmaps
 
@@ -87,7 +95,7 @@
         self.UpdateWhenIdle()
         self.compute_trafo()
 
-
+    
 class InteractiveSample(PatternSample, Publisher):
 
     allow_edit_center = 0
@@ -107,11 +115,13 @@
         self.drawn = 0
         self.dragging = 0
         self.drag_button = None
-
+        
+    
     def destroy(self):
         Publisher.Destroy(self)
         PatternSample.destroy(self)
 
+        
     def SetEditMode(self, center, direction):
         self.allow_edit_center = center
         self.allow_edit_dir = direction
@@ -121,7 +131,7 @@
         x, y = pos
         x =      x  * width
         y = (1 - y) * height
-        self.center = (x, y)
+        self.center = map(int, (x, y))
 
     def init_gcs(self):
         PatternSample.init_gcs(self)
@@ -184,9 +194,9 @@
         if self.current_mode == 0:
             if constraint:
                 x, y = self.constrain_center(x, y)
-                x = int(x)
-                y = int(y)
             width, height = self.window.get_size()
+            x = int(x)
+            y = int(y)
             self.window.draw_line(self.inv_gc, 0, y, width, y)
             self.window.draw_line(self.inv_gc, x, 0, x, height)
         else:
@@ -261,6 +271,9 @@
     def EditModes(self):
         return (0, 0)
 
+    def Passivate(self):
+        pass
+    
 
 class EmptyPatternFrame(gtk.VBox, PatternFrame):
 
@@ -274,35 +287,47 @@
 
 class SolidPatternFrame(gtk.VBox, PatternFrame):
 
-    def __init__(self):
+    def __init__(self, application):
         gtk.VBox.__init__(self)
-        PatternFrame.__init__(self, SolidPattern(StandardColors.black))
-        button = gtk.Button(_("Choose Color..."))
-        self.pack_start(button, expand = 0)
-        button.show()
-        button.connect("clicked", self.ChooseColor)
+        color = StandardColors.black
+        PatternFrame.__init__(self, SolidPattern(color))
+        self.button = ColorRequestButton(application,
+                                         _("Choose Color..."),
+                                         color)
+        self.pack_start(self.button, expand = 0)
+        self.button.show()
+        self.button.Subscribe(CHANGED, self.Set)
 
     def ChooseColor(self, *args):
         color = get_color(_("Select Fill Color"), self.pattern.Color())
         if color is not None:
-            self.SetPattern(SolidPattern(color))
-            self.changed()
+            self.Set(color)
+            
+    def Set(self, color):        
+        self.SetPattern(SolidPattern(color))
+        self.changed()
 
+    def Passivate(self):
+        self.button.Passivate()
+        
 
 class GradientPatternFrame(gtk.VBox, PatternFrame):
 
-    def __init__(self):
+    def __init__(self, application):
         gtk.VBox.__init__(self)
         start_color = StandardColors.black
         end_color = StandardColors.white
         gradient = CreateSimpleGradient(start_color, end_color)
         PatternFrame.__init__(self, LinearGradient(gradient))
         box = gtk.HBox()
-        self.start_button = ColorButton(_("Start"), _("Start Color"),
+        self.start_button = ColorButton(application,
+                                        _("Start"),
                                         start_color)
         self.start_button.Subscribe(CHANGED, self.set_color, 0)
         box.pack_start(self.start_button)
-        self.end_button = ColorButton(_("End"), _("End Color"), end_color)
+        self.end_button = ColorButton(application,
+                                      _("End"),
+                                      end_color)
         self.end_button.Subscribe(CHANGED, self.set_color, 1)
         box.pack_start(self.end_button)
         self.pack_start(box, expand = 0)
@@ -460,17 +485,22 @@
             self.SetPattern(self.pattern.WithDirection(dir))
             self.changed()
 
+    def Passivate(self):
+        self.start_button.Passivate()
+        self.end_button.Passivate()
+        
+
 class HatchingPatternFrame(gtk.VBox, PatternFrame):
 
-    def __init__(self):
+    def __init__(self, application):
         gtk.VBox.__init__(self)
         fg = StandardColors.red
         bg = StandardColors.white
         PatternFrame.__init__(self, HatchingPattern(fg, bg))
-        self.fg_button = ColorButton(_("Foreground"),_("Foreground Color"), fg)
+        self.fg_button = ColorButton(application, _("Foreground"), fg)
         self.fg_button.Subscribe(CHANGED, self.set_color, 0)
         self.pack_start(self.fg_button, expand = 0)
-        self.bg_button = ColorButton(_("Background"),_("Background Color"), bg)
+        self.bg_button = ColorButton(application, _("Background"), bg)
         self.bg_button.Subscribe(CHANGED, self.set_color, 1)
         self.pack_start(self.bg_button, expand = 0)
 
@@ -494,6 +524,10 @@
         self.SetPattern(pattern)
         self.changed()
 
+    def Passivate(self):
+        self.bg_button.Passivate()
+        self.fg_button.Passivate()
+
 
 class ImageTilePatternFrame(gtk.VBox, PatternFrame):
 
@@ -504,32 +538,40 @@
         self.pack_start(label)
         label.show()
 
-class FillPanel(SketchPanel):
-
-    def __init__(self, context):
-        SketchPanel.__init__(self, context, _("Fill"))
-        self.context.Subscribe(Sketch.Base.const.SELECTION,
-                               self.context_changed)
+class FillInspector(Card):
+    def __init__(self, application):
+        Card.__init__(self, application, _("Fill"))
         self.active_frame = None
-        self.set_name("fill_panel")
-
-    def destroyed(self, *args):
-        self.context.Unsubscribe(Sketch.Base.const.SELECTION,
-                                 self.context_changed)
-        apply(SketchPanel.destroyed, (self,) + args)
-
-    def build_window(self):
-        vbox = self.vbox
+        self.has_changes = 1
 
+        # locks fulfill two tasks here: blocking "apply" and blocking
+        # the unsetting of the "undo_last" flag.        
+        self.locked = 0
+
+        # a flag which signals whether the last transactions should be
+        # undone when the next one is applied. The flag is unset
+        # automatically when antoher transaction happend or the
+        # selection changes .
+        self.undo_last = 0
+
+        for signal in (CHANGED, SELECTION, EDITED, OBJECT_CHANGED):
+            self.context.Subscribe(signal, self.context_changed)
+
+    def build_card(self):
+        application = self.context.application
+        
         self.sample = InteractiveSample()
         self.sample.set_size_request(100, 100)
-        vbox.pack_start(self.sample)
+        self.pack_start(self.sample)
         self.sample.Subscribe(EDITED, self.sample_edited)
+        self.sample.drag_dest_set(gtk.DEST_DEFAULT_ALL, dnd.color_target,
+                                  gtk.gdk.ACTION_COPY | gtk.gdk.ACTION_MOVE)
+        self.sample.connect('drag_data_received', self.drag_data_received)
 
         self.empty_frame = EmptyPatternFrame()
-        self.solid_frame = SolidPatternFrame()
-        self.gradient_frame = GradientPatternFrame()
-        self.hatching_frame = HatchingPatternFrame()
+        self.solid_frame = SolidPatternFrame(application)
+        self.gradient_frame = GradientPatternFrame(application)
+        self.hatching_frame = HatchingPatternFrame(application)
         self.imagetile_frame = ImageTilePatternFrame()
 
         menu = gtk.Menu()
@@ -544,12 +586,12 @@
             item.show()
             item.connect("activate", self.set_pattern_type, frame)
             notebook.append_page(frame, gtk.Label(name))
-            frame.Subscribe(CHANGED, self.update_sample, frame)
+            frame.Subscribe(CHANGED, self.frame_changed, frame)
 
         self.optionmenu = gtk.OptionMenu()
         self.optionmenu.set_menu(menu)
-        vbox.pack_start(self.optionmenu, expand = 0)
-        vbox.pack_start(notebook)
+        self.pack_start(self.optionmenu, expand = 0)
+        self.pack_start(notebook)
         notebook.set_show_tabs(0)
 
         box = gtk.HBox()
@@ -562,57 +604,75 @@
                                              lower = 0, upper = 100,
                                              step_incr = 1)
         entry = gtk.SpinButton(adjustment = self.adjust_opacity, digits = 0)
+        entry.connect('changed', self.auto_apply)
         box.pack_start(entry)
-        vbox.pack_start(box, expand = 0)
+        self.pack_start(box, expand = 0)
+        self.show_all()
 
-        self.apply_button = button = gtk.Button(_("Apply"))
-        button.connect("clicked", self.do_apply)
-        self.action_area.pack_start(button, expand = 0, fill = 0)
-        button = gtk.Button(_("Close"))
-        button.connect("clicked", self.close)
-        self.action_area.pack_start(button, expand = 0, fill = 0)
+    def drag_data_received(self, w, context, x, y, data, info, time):
+        d = data.data
 
-        vbox.show_all()
+        if data and data.format == 16:
+            color = dnd.decode_color(data)
+            self.activate_frame(self.solid_frame)            
+            self.solid_frame.Set(color)            
+            self.auto_apply()
+            context.finish(gtk.TRUE, gtk.FALSE, time)
+        else:
+            context.finish(gtk.FALSE, gtk.FALSE, time)
 
     def set_pattern_type(self, widget, frame):
         self.activate_frame(frame)
 
-    def context_changed(self, *args):
-        if self.context.HasEditor():
-            self.apply_button.set_sensitive(1)
-            object = self.context.editor.CurrentObject()
-            if object is not None:
-                if object.has_fill:
-                    pattern = object.Properties().fill_pattern
-                    frame = self.empty_frame
-                    if pattern.is_Solid:
-                        frame = self.solid_frame
-                    elif pattern.is_Gradient:
-                        frame = self.gradient_frame
-                    elif pattern.is_Hatching:
-                        frame = self.hatching_frame
-                    elif pattern.is_Image:
-                        frame = self.imagetile_frame
-                    if frame is not None:
-                        frame.SetPattern(pattern)
-                        self.activate_frame(frame)
+    def lock(self):        
+        self.locked = 1
 
-                    opacity = object.Properties().fill_opacity
-                    self.adjust_opacity.set_value(round(opacity * 100))
-        else:
-            self.apply_button.set_sensitive(0)
+    def unlock(self):
+        self.locked = 0
+        
+    def update(self):
+        if not self.context.HasEditor() or self.window is None:
+            return
+        
+        self.lock()        
+        object = self.context.editor.CurrentObject()
+        if object is not None:
+            if object.has_fill:
+                pattern = object.Properties().fill_pattern
+                frame = self.empty_frame
+                if pattern.is_Solid:
+                    frame = self.solid_frame
+                elif pattern.is_Gradient:
+                    frame = self.gradient_frame
+                elif pattern.is_Hatching:
+                    frame = self.hatching_frame
+                elif pattern.is_Image:
+                    frame = self.imagetile_frame
+                if frame is not None:
+                    frame.SetPattern(pattern)
+                    self.activate_frame(frame)
+
+                opacity = object.Properties().fill_opacity
+                self.adjust_opacity.set_value(round(opacity * 100))
+                
+        self.has_changes = 0
+        self.changed()
+        self.unlock()
 
     def activate_frame(self, frame):
+        if self.active_frame is not None:
+            self.active_frame.Passivate()
         self.active_frame = frame
         index = self.notebook.page_num(frame)
         self.notebook.set_current_page(index)
         self.optionmenu.set_history(index)
-        self.update_sample(frame)
+        self.frame_changed(frame)
 
-    def update_sample(self, frame):
+    def frame_changed(self, frame):
         self.sample.SetPattern(frame.Pattern())
         self.sample.SetCenter(frame.Center())
         apply(self.sample.SetEditMode, frame.EditModes())
+        self.auto_apply()
 
     def sample_edited(self, what, detail):
         if self.active_frame is not None:
@@ -620,11 +680,77 @@
                 self.active_frame.SetCenter(detail)
             else:
                 self.active_frame.SetDirection(detail)
+            self.auto_apply()
+        
+    def CanApply(self):
+        return self.has_changes
+    
+    def context_changed(self, *args):        
+        if self.locked:
+            return
+        
+        self.has_changes = 1
+        self.undo_last = 0
+        if self.IsAutoUpdate():
+            self.update()
+        else:
+            self.changed()
 
-    def do_apply(self, *args):
-        if self.active_frame is not None and self.context.HasEditor():
-            pattern = self.active_frame.Pattern()
-            opacity = self.adjust_opacity.value / 100.0
-            self.context.editor.SetProperties(fill_pattern = pattern,
-                                              fill_opacity = opacity)
+    def auto_apply(self, *args):
+        if self.locked:
+            return
+        
+        self.has_changes = 1
+        if self.IsAutoApply():
+            self.do_apply()
+        else:
+            self.changed()
+            
+    def do_apply(self, all=0):
+        context = self.context
+        if not context.HasEditor():
+            return
 
+        self.has_changes = 0
+        
+        # prevent the undo_last flag from being unset  
+        self.lock()
+        pattern = self.active_frame.Pattern()
+        opacity = self.adjust_opacity.value / 100.0
+        undo = context.document.undo
+        
+        if self.undo_last:
+            undo.Undo() 
+            
+        context.editor.SetProperties(fill_pattern = pattern,
+                                     fill_opacity = opacity)
+        self.undo_last = 1
+        self.unlock()
+        self.changed()
+        
+
+class FillPanel(MultiPanel):
+    multiple = 1
+    def __init__(self, context):
+        MultiPanel.__init__(self, context, _("Fill"))
+
+    def build_window(self):
+        MultiPanel.build_window(self)
+        card = FillInspector(self.context.application)
+        self.build_menu()
+        self.attach_card(card)
+
+    def build_menu(self):        
+        items = (
+            #'issue_panel_changed',
+                 'close_panel',
+                 'duplicate_panel',
+                 None,
+                 'auto_update',
+                 'auto_apply',
+                 'update_panel',
+                 'do_apply')
+        #tree = Sketch.BuildMenuTree('<fillmenu>', '', items)
+        import tmpmenu
+        tree = tmpmenu.BuildMenuTree('<fillmenu>', '', items)
+        self.set_menudata(tree)
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/gtkmisc.py sketch1/Sketch/UI/gtkmisc.py
--- sketch.orig/Sketch/UI/gtkmisc.py	2005-03-19 18:48:56.000000000 +0100
+++ sketch1/Sketch/UI/gtkmisc.py	2005-03-19 20:27:08.000000000 +0100
@@ -17,10 +17,38 @@
 
 import os
 import gtk
+import Sketch
+import types
+import math
 from Sketch import _, _skgtk
 from Sketch.Base import Publisher, const
 from Sketch.Graphics import CreateRGBColor
 from gtkdevice import GraphicsDevice
+from Sketch.Lib.units import unit_dict
+import skpixmaps
+import gobject
+
+                  
+class CommandButton(gtk.Button):
+    def __init__(self, command, context):
+        gtk.Button.__init__(self)
+        self.command = command
+        self.context = context
+        self.subscribe()
+        self.clicked_id = self.connect('clicked', self.call_command)
+
+    def subscribe(self):
+        for channel in self.command.channels:
+            self.context.Subscribe(channel, self.changed)
+        self.context.Subscribe(Sketch.Base.const.CHANGED, self.changed)
+        self.changed()
+
+    def changed(self, *args):
+        self.set_sensitive(self.command.Sensitive(self.context))
+
+    def call_command(self, widget):
+        self.command.Execute(self.context)
+
 
 
 class MessageBox(gtk.Dialog):
@@ -184,59 +212,29 @@
         return CreateRGBColor(gdk_color.red / 65536.0,
                               gdk_color.green / 65536.0,
                               gdk_color.blue / 65536.0)
-
-
+    
 def get_color(title, color = None):
     win = ColorDialog(title, color)
     return win.run()
 
-def _gtk_colors(cmap, color):
-    r, g, b = color
-    bg = cmap.alloc_color(int(round(r * 0xFFFF)),
-                          int(round(g * 0xFFFF)),
-                          int(round(b * 0xFFFF)))
-    luminance = 0.30*r + 0.59*g + 0.11*b
-    #luminance = (min(color) + max(color)) / 2
-    if luminance > 0.5:
-        fg = cmap.alloc_color(0, 0, 0)
-    else:
-        fg = cmap.alloc_color(0xFFFF, 0xFFFF, 0xFFFF)
-    return fg, bg
-
-class ColorButton(gtk.Button, Publisher):
-
-    def __init__(self, title, dialog_title, color):
-        gtk.Button.__init__(self, title)
-        self.dialog_title = dialog_title
-        self.color = color
-        self.connect("clicked", self.choose_color)
-        self.connect("realize", self.realized)
-
-    def realized(self, *args):
-        self.SetColor(self.color)
-
-    def SetColor(self, color):
-        self.color = color
-        style = self.get_style().copy()
-        fg, bg = _gtk_colors(self.get_colormap(), color)
-        for i in range(5):
-            style.fg[i] = fg
-            style.bg[i] = bg
-        self.set_style(style)
-        self.get_children()[0].set_style(style)
-
-    def Color(self):
-        return self.color
+            
+class FontDialog(ModalDialogMixin, gtk.FontSelectionDialog):
 
-    def choose_color(self, *args):
-        color = get_color(self.dialog_title, self.color)
-        if color is not None:
-            self.SetColor(color)
-            self.issue(const.CHANGED, self.color)
+    def __init__(self, title, font = None):
+        gtk.FontSelectionDialog.__init__(self, title)
+        ModalDialogMixin.__init__(self)
+        if font is not None:
+            pass
 
+    def get_result(self):
+        return self.get_font_name()
+    
+def get_color(title, color = None):
+    win = ColorDialog(title, color)
+    return win.run()
 
 class SketchDrawingArea(gtk.DrawingArea):
-
+    _size = (0,0)
     def __init__(self, **kw):
         gtk.DrawingArea.__init__(self, **kw)
         self.region = _skgtk.create_region()
@@ -251,7 +249,17 @@
         self.connect("configure_event", self.configure_event)
         self.connect("focus_in_event", self.focus_in_event)
         self.connect("focus_out_event", self.focus_out_event)
+        self.connect("size-allocate", self.size_allocate)
 
+    def size_allocate(self, widget, rectangle): #XXX chris
+        """Widget is resized"""
+        x, y, w, h = rectangle
+        self._size = w, h
+        #print "allocated resize:", w, h
+        
+    def get_size(self):
+        return self._size
+    
     def focus_in_event(self, widget, event):
         """Handle focus_in_event
 
@@ -271,7 +279,9 @@
         return gtk.TRUE
 
     def configure_event(self, widget, event):
+        #print "configure event", widget, event.width, event.height
         self.ResizedMethod(event.width, event.height)
+        
 
     def ResizedMethod(self, width, height):
         # to be implemented by derived classes
@@ -299,3 +309,186 @@
     def init_gcs(self):
         self.gc.init_gc(self.window, graphics_exposures = 1)
         self.gcs_initialized = 1
+
+
+
+class CommonOptionMenu(gtk.OptionMenu, Publisher):
+
+    """Base class for specialized option menus
+
+    Base class for specialized option menus such as line widths and
+    arrows. The derived class should pass VALUES to the CommonOptionMenu
+    constructor. VALUES is a list of the actual option values (numbers,
+    class instances, tuples, etc.) that are returned by GetOption() and
+    passed with the CHANGED signal when an option is selected.
+
+    Override build_options() to return a two-tuple: a list of the items
+    to be placed in the menu and the default menu index. The menu items
+    can be strings (converted to vanilla GtkMenuItems) or gtk widgets
+    (such as GtkPixmaps) which are added to the GtkMenuItems.
+
+    The class variable MODE can be FIXED (SetOption ignores values not
+    already in the option menu), EXTEND (SetOption adds new values to
+    the menu), or TEMPORARY_EXTENSION (SetOption adds a new value by
+    combining it with the values set at construction). See the
+    specialized menu classes below for more details.
+    """
+
+    FIXED = 0
+    EXTEND = 1
+    TEMPORARY_EXTENSION = 2
+
+    mode = FIXED
+
+    def __init__(self, values = []):
+        gtk.OptionMenu.__init__(self)
+        self.base_values = values
+        self.values = values
+        self.idx = None
+        self.initialized = 0
+        self.connect('realize', self.on_realize)
+        self.connect('expose_event', self.on_expose_event)
+        self.connect('configure_event', self.on_configure_event)
+
+    def on_realize(self, *args):
+        if not self.initialized:
+            self.initialize()
+
+    def on_expose_event(self, *args):
+        if not self.initialized:
+            self.initialize()
+
+    def on_configure_event(self, widget, event):
+        self.resized(width, height)
+                
+    def initialize(self):
+        self.update()
+
+    def resized(self, width, height):
+        pass
+
+    def build_options(self):
+        return [], None
+
+    def update(self):
+        self.menu = menu = gtk.Menu()
+        options, default = self.build_options()
+        idx = 0
+        for option in options:
+            if isinstance(option, types.StringType):
+                item = gtk.MenuItem(option)
+            else:
+                item = gtk.MenuItem()
+                item.add(option)
+            item.connect('activate', self.on_select, idx)
+            menu.append(item)
+            idx = idx + 1
+        menu.show_all()
+        self.set_menu(menu)
+        self.idx = default
+        self.set_history(default)
+        self.initialized = 1
+
+    def on_select(self, widget, idx, *args):
+        self.issue(const.CHANGED, self.values[idx])
+        self.idx = idx
+
+    def GetOption(self):
+        return self.values[self.idx]
+
+    def HasOption(self, value):
+        return not not self.values.count(value)
+
+    def SetOption(self, value):
+        if not self.values.count(value):
+            if self.mode == CommonOptionMenu.FIXED:
+                return
+            if self.mode == CommonOptionMenu.TEMPORARY_EXTENSION:
+                self.values = self.base_values
+            self.values.append(value)
+            self.update()
+        idx = self.values.index(value)
+        self.idx = idx
+        self.set_history(self.idx)
+
+
+
+class PixmapMenu(CommonOptionMenu):
+
+    """OptionMenu displaying Pixmaps"""
+
+    def __init__(self, pixmaps, values):
+        """Initialize the PixmapMenu
+
+        Parameters:
+           pixmaps - list of GtkPixmaps or strings (from skpixmaps)
+           values  - list of associated values
+        """
+        CommonOptionMenu.__init__(self, values)
+        self.pixmaps = pixmaps
+
+    def build_options(self):
+        options = []
+        for pixmap in self.pixmaps:
+            if isinstance(pixmap, types.StringType):
+                pixmap = getattr(skpixmaps.pixmaps, pixmap)
+            image = gtk.Image()
+            image.set_from_pixmap(*pixmap)
+            options.append(image)
+        return options, 0
+
+class UnitMenu(CommonOptionMenu):
+
+    """Unit Menu
+
+    The values are (unit, scale) tuples, such as ("in", 72.0)
+    The default unit is taken from Sketch.UI.preferences
+    """
+    def __init__(self):
+        self.units = unit_dict.keys()
+        self.units.sort()
+        values = map(lambda x: (x, unit_dict[x]), self.units)
+        CommonOptionMenu.__init__(self, values)
+        default_unit = Sketch.UI.preferences.default_unit
+        if self.units.count(default_unit) > 0:
+            self.idx = self.units.index(default_unit)
+
+    def build_options(self):
+        return self.units, self.idx
+
+class AngleUnitMenu(CommonOptionMenu):
+    angular_units = {
+        'deg' : 1.,
+        'rad' : 180./math.pi
+        }
+    def __init__(self):
+        unit_dict = self.angular_units
+        self.units = unit_dict.keys()
+        self.units.sort()
+        values = map(lambda x: (x, unit_dict[x]), self.units)
+        CommonOptionMenu.__init__(self, values)
+        default_unit = 'deg'
+        if self.units.count(default_unit) > 0:
+            self.idx = self.units.index(default_unit)
+
+    def build_options(self):
+        return self.units, self.idx
+
+    
+def create_length_widgets(command):
+    label = gtk.Label(_("Width:"))
+    adjust = gtk.Adjustment(1, 0, 72, 1, 0, 0)
+    width = gtk.SpinButton(adjust)
+    width.connect('changed', command)
+    unit_menu = UnitMenu()
+    unit_menu.Subscribe(const.CHANGED, command)
+    return label, width, unit_menu
+
+def create_length_entry(master, command):
+    width_hbox = gtk.HBox(homogeneous = 0)
+    label, width, unit_menu = create_length_widgets(command)
+    width_hbox.pack_start(label, 0, 1)
+    width_hbox.pack_start(width, 1, 1)
+    width_hbox.pack_start(unit_menu, 0, 1) 
+    master.pack_start(width_hbox)
+    return width
diff -trNau -U 3 -x '*o' -x '*.pyc' -x '*~*' -x '*.Log' -x NEWS -x CVS -x build sketch.orig/Sketch/UI/inspectorpanel.py sketch1/Sketch/UI/inspectorpanel.py
--- sketch.orig/Sketch/UI/inspectorpanel.py	1970-01-01 01:00:00.000000000 +0100
+++ sketch1/Sketch/UI/inspectorpanel.py	2005-03-19 20:27:08.000000000 +0100
@@ -0,0 +1,39 @@
+from Sketch import _, Editor
+from skpanel import MultiPanel
+from linepanel import LineInspector
+from fillpanel import FillInspector
+from properties import PropertyInspector
+
+class InspectorPanel(MultiPanel):
+    multiple = 1
+    def __init__(self, context):
+        MultiPanel.__init__(self, context, _("Inspector"))
+        self.set_resizable(0)
+
+    def build_window(self):
+        MultiPanel.build_window(self)
+        self.build_menu()
+
+        application = self.context.application
+        card = LineInspector(application)
+        self.attach_card(card)        
+        card = FillInspector(application)
+        self.attach_card(card)
+        card = PropertyInspector(application)
+        self.attach_card(card)
+
+
+    def build_menu(self):        
+        items = (
+            #'issue_panel_changed',
+                 'close_panel',
+                 'duplicate_panel',
+                 None,
+                 'auto_update',
+                 'auto_apply',
+                 'update_panel',
+                 'do_apply')
+
+        import tmpmenu
+        menudata = tmpmenu.BuildMenuTree('<fillmenu>', '', items)
+        self.set_menudata(menudata)
